  

rm(list=ls())
library(remMap)

library(MASS)
library(elasticnet)
library(glmnet)
library(spls)
library("mvtnorm")
source("multiple_regression_v2.R")
 
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#setwd("D:/SPLS-rbp/Setting1")


total.repeat <- 50

for(n.repeat in 1:total.repeat)
{ 
    for(total.noise in c(0.1, 0.15))
   { 
     for(rho in c(0.3, 0.7))
    {
      for(rho.e in c(0.2, 0.9))
    {
nvar=500
 nvarq <- 3
sigma2 <- total.noise/nvarq
sigmaX=0.1
  
repeat.solution <- 1
 
K.comp <- nvarq
nvar.eff=150
 
K.cv=5

Sigma=matrix(0,nvar.eff,nvar.eff)
for(i in 1:nvar.eff){
    for(j in 1:nvar.eff){
        Sigma[i,j]=rho^(abs(i-j))
    }
}
Sigma <- Sigma

Sigma2.y <- matrix(sigma2*rho.e,nvarq, nvarq)
diag(Sigma2.y) <- sigma2

betas.true <- matrix(0, nvar, 3)
betas.true[1:15,1]=rep(1,15)/sqrt(15)
betas.true[16:45,2]=rep(0.5,30)/sqrt(30)
betas.true[46:105,3]=rep(0.25,60)/sqrt(60)
 
  

nvar.use <- 60
sel0 <- c(rep(1,nvar.use),rep(0,nvar-nvar.use))

srrr.error <- splscv.error <- splscv1.error <- glmnetcv.error <- rp10.error <- rp10.error1 <- rp10.error0 <- rep(0,total.repeat)
srrr.feature <- rp10.feature <- rp10.feature1 <- rp10.feature0 <- splscv.feature <- splscv1.feature <- n.feature <- glmnetcv.feature <- rep(0,total.repeat)
srrr.true.feature <- rp10.true.feature <- rp10.true.feature1 <-  rp10.true.feature0 <- splscv.true.feature <- splscv1.true.feature <- n.true.feature <- glmnetcv.true.feature <- rep(0, total.repeat)
rp10.nfactors0 <- rp10.nfactors1 <- rp10.nfactors <- splscv.nfactors <- splscv1.nfactors <- srrr.nfactors <- rep(0,total.repeat)
times.all <- matrix(0,total.repeat,5)

#params.set <- matrix(c( 0.1, 0.1, 0.5 ,     0.05, 0.1, 0.1 ), ncol=2, byrow=FALSE)
#params.set <- matrix(c(0.05, 0.1, 0.1,0.5,   0.05, 0.05, 0.1,0.1), ncol=2, byrow=FALSE)
#params.set <- matrix(c(0.01, 0.1, 1, 10,  0.05, 0.5, 5, 1, 10,100,5,50,100, rep(.05,4), rep(.3,3), rep(c(0.6,0.9),each=3)), ncol=2, byrow=FALSE)
 params.set <- cbind(c(0.05, 0.1,  0.1, 0.5, 0.5, 1,   1,   5,   5,  10),
                     c(0.05, 0.05, 0.1, 0.1, 0.2, 0.2, 0.3, 0.3, 0.4, 0.4)) 


ntest <- 500
ntrain <- 90
ntot <- ntest+ntrain
scalex <- 0


filename.error <- paste("sim.SiER.1_p=", nvar, "_q=", nvarq,  "_neff=", nvar.eff, "_sigma2=",sigma2,"_sigmaX=",sigmaX,"_rho=",rho,"_noisecor=",rho.e,".error.txt",sep="")
filename.feature <- paste("sim.SiER.1_p=", nvar, "_q=", nvarq,  "_neff=", nvar.eff, "_sigma2=",sigma2,"_sigmaX=",sigmaX,"_rho=",rho,"_noisecor=",rho.e,".feature.txt",sep="")
    print(t(c("p=",nvar, "_q=", nvarq, "sigma2=",sigma2,"rho=",rho,"rho.e=",rho.e)))

     X=matrix(0,ntot,nvar)
    X[,1:nvar.eff]=mvrnorm(n=ntot, rep(0, nvar.eff), Sigma)
    X[,-(1:nvar.eff)]=matrix(sigmaX*rnorm((nvar-nvar.eff)*dim(X)[1]),dim(X)[1],(nvar-nvar.eff))

    Y <- X%*%betas.true
    Y <- Y+mvrnorm(n=ntot, rep(0,nvarq), Sigma2.y)

    X.train <- X[1:ntrain,]
    Y.train <- Y[1:ntrain,]
    x.test <- X[-(1:ntrain),]
    y.test <- Y[-(1:ntrain),]

     
    
    t0 <- proc.time()[3]
     max.K <- determineMaxKcomp(X.train, Y.train, params.set, tol)$max.K
    print(max.K)
       cv10.ret1 <- CV.SIER(X.train,Y.train, max.K, params.set, K.cv=5)
 
    alltrain10.ret1 <- getAllComponents(X.train, Y.train, cv10.ret1$opt.K1, cv10.ret1$min.tau1, cv10.ret1$min.mu1)
    z.x.test <- scale(x.test, alltrain10.ret1$mux, scale=FALSE)
    z.y.test <- scale(y.test, alltrain10.ret1$muy, scale=FALSE)
    rp10.error[n.repeat]=getError(alltrain10.ret1$z.x, alltrain10.ret1$z.y, z.x.test, z.y.test, alltrain10.ret1$Beta)/ntest
 print(rp10.error[n.repeat])
       times <- proc.time()[3]-t0;
print(times)

    test.error.all <- cbind( rp10.error[n.repeat], cv10.ret1$opt.K1,  cv10.ret1$min.tau1, cv10.ret1$min.mu1, times)  

    write.table((test.error.all),filename.error, row.names=F, col.names=F, append=T)
   

}
}}}



