 # Y: n*1
# compare spls.rp, spls and regression by projection


rm(list=ls())
library(remMap)

library(MASS)
library(elasticnet)
library(glmnet)
library(spls)
library("mvtnorm")
source("multiple_regression_v2.R")
 
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#setwd("D:/SPLS-rbp/Setting1")


total.repeat <- 50

for(n.repeat in 1:total.repeat)
{ 
 for(nvar in c(1000,2000))
  {
   for(nvarq in c(100, 200))
   { 
     for(gamma.value in c(1,2))
    {


sigmaX=0.1
sigma2 <- 0.3/nvarq
rho.e <- 0.5 

rho <- 0.5
   
repeat.solution <- 1
 
K.comp <- nvarq
nvar.eff=200
nvar.feature=100
K.cv=5
 

Sigma=matrix(0,nvar.eff,nvar.eff)
for(i in 1:nvar.eff){
    for(j in 1:nvar.eff){
        Sigma[i,j]=rho^(abs(i-j))
    }
}
Sigma <- (Sigma+t(Sigma))/2

Sigma.beta =matrix(0,nvarq,nvarq)
for(i in 1:nvarq){
    for(j in 1:nvarq){
        Sigma.beta[i,j]=exp(-(abs(i-j)/100)^gamma.value)
    }
}
Sigma.beta <- (Sigma.beta+t(Sigma.beta))/2

 
Sigma2.y <- matrix(sigma2*rho.e,nvarq, nvarq)
diag(Sigma2.y) <- sigma2

#Y=X %*% coef %*% bs.true, X: n*p, coef: p*ncomp, bs.true: ncomp*q
ncomp.true <- 3


nvar.use <- nvar.feature
sel0 <- c(rep(1,nvar.use),rep(0,nvar-nvar.use))


remMap.error=srrr.error <- splscv.error <- splscv1.error <- glmnetcv.error <- rp10.error <- rp10.error  <- rep(0,total.repeat)
remMap.feature <-srrr.feature <- rp10.feature     <- splscv.feature <- splscv1.feature <- n.feature <- glmnetcv.feature <- rep(0,total.repeat)
remMap.true.feature <-srrr.true.feature <- rp10.true.feature <- rp10.true.feature1 <-  rp10.true.feature0 <- splscv.true.feature <- splscv1.true.feature <- n.true.feature <- glmnetcv.true.feature <- rep(0, total.repeat)
rp10.nfactors0 <- rp10.nfactors1 <- rp10.nfactors <- splscv.nfactors <- splscv1.nfactors <- srrr.nfactors <- rep(0,total.repeat)
times.all <- matrix(0,total.repeat,5)

params.set <- cbind(c(0.05, 0.1,  0.1, 0.5, 0.5, 1,   1),
                     c(0.05, 0.05, 0.1, 0.1, 0.2, 0.2, 0.3)) 

ntest <- 500
ntrain <- 90
ntot <- ntest+ntrain
scalex <- 0


filename.error <- paste("sim.3.SiER_p=", nvar, "_q=", nvarq,"_gamma=", gamma.value, "_nfeature=", nvar.feature,"_neff=", nvar.eff, "_sigma2=",sigma2,"_sigmaX=",sigmaX,"_rho=",rho,"_noisecor=",rho.e,".error.txt",sep="")
filename.feature <- paste("sim.3.SiER_p=", nvar, "_q=", nvarq,"_gamma=", gamma.value, "_nfeature=", nvar.feature,"_neff=", nvar.eff, "_sigma2=",sigma2,"_sigmaX=",sigmaX,"_rho=",rho,"_noisecor=",rho.e,".feature.txt",sep="")
    print(t(c("p=",nvar, "_q=", nvarq, "_gamma=", gamma.value, "sigma2=",sigma2,"rho=",rho,"rho.e=",rho.e)))
    
     bs.true <-  mvrnorm(n=ncomp.true, rep(0, nvarq), Sigma.beta)
     tmp=sqrt(apply(bs.true^2,1,sum))
     for(i in 1:3)
      {bs.true[i,]=bs.true[i,]/tmp[i]}
     coefs <- matrix(0, nvar, ncomp.true)
     coefs[1:nvar.feature,]= matrix(rnorm(nvar.feature*ncomp.true), nvar.feature, ncomp.true)
     coefs=scale(coefs, center =FALSE, scale =sqrt(apply(coefs^2,2,sum)))

     betas.true <- coefs %*% bs.true
     
    
    X=matrix(0,ntot,nvar)
    X[,1:nvar.eff]=mvrnorm(n=ntot, rep(0, nvar.eff), Sigma)
     X[,-(1:nvar.eff)]=matrix(sigmaX*rnorm((nvar-nvar.eff)*dim(X)[1]),dim(X)[1],(nvar-nvar.eff))
   
    Z <- X%*%betas.true
    Y <- Z+mvrnorm(n=ntot, rep(0,nvarq), Sigma2.y)

    X.train <- X[1:ntrain,]
    Y.train <- Y[1:ntrain,]
    x.test <- X[-(1:ntrain),]
    y.test <- Y[-(1:ntrain),]
    z.test <- Z[-(1:ntrain),]

     
    
    t0 <- proc.time()[3]
     max.K <- determineMaxKcomp(X.train, Y.train, params.set, tol)$max.K
    print(max.K)
       cv10.ret1 <- CV.SIER(X.train,Y.train, max.K, params.set, K.cv=5)
 
    alltrain10.ret1 <- getAllComponents(X.train, Y.train, cv10.ret1$opt.K1, cv10.ret1$min.tau1, cv10.ret1$min.mu1)
    z.x.test <- scale(x.test, alltrain10.ret1$mux, scale=FALSE)
    z.y.test <- scale(y.test, alltrain10.ret1$muy, scale=FALSE)
    rp10.error[n.repeat]=getError(alltrain10.ret1$z.x, alltrain10.ret1$z.y, z.x.test, z.y.test, alltrain10.ret1$Beta)/ntest
 print(rp10.error[n.repeat])
       times <- proc.time()[3]-t0;
print(times)

    test.error.all <- cbind( rp10.error[n.repeat], cv10.ret1$opt.K1,  cv10.ret1$min.tau1, cv10.ret1$min.mu1, times)  

    write.table((test.error.all),filename.error, row.names=F, col.names=F, append=T)
   

}
}}}

